/*
   Pseudo

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2006 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Mset extends Controler {
  private MsetCoder coder ;
  private int t [] ;
  private int rem ;

  Mset(String s) {
    coder = new MsetCoder(s) ;
    t = new int[coder.card()] ;
    for (int k = 0 ; k < s.length() ; k++) {
      char c = s.charAt(k) ;      
      int x = coder.code(c) ;
      t[x]++ ;
      rem++ ;
    }
  }

  Coder getCoder() { return coder ; }

  public boolean transition(char c) {
    if (t[c] == 0) {
      return false ;
    } else {
      t[c]-- ; rem-- ;
      return true ;
    }
  }

  public boolean accept() {
    return rem == 0 ;
  }

  public void back(char c) {
    t[c]++ ; rem++ ;
  }

  public boolean goodWord(String w) {
    for (int k = 0 ; k < w.length() ; k++) {
      char c = w.charAt(k) ;
      if (!transition(c)) {
	for (int kk = k-1 ; kk >= 0 ; kk--) {
	  back(w.charAt(kk)) ;
	}
	return false ;
      }
    }
    for (int k = w.length()-1 ; k >= 0  ; k--) {
      back(w.charAt(k)) ;
    }
    return true ;
  }

  public String toString() {
    StringBuffer r = new StringBuffer () ;
    for (int k = 0 ; k < t.length ; k++) {
      r.append((char)coder.decode(k) + "<" + t[k] + ">") ;
    }
    r.append(" {" + rem + "}") ;
    return r.toString() ;
  }

  public static void main(String [] arg) {
    Mset s = new Mset(arg[0]) ;
    System.out.println(s) ;
  }
}
